#include "../config.h"
#include "Battery.h"
#include <Wire.h>
#include <Arduino.h>

WatchFeatures::Battery::Battery()
{
}

float WatchFeatures::Battery::GetVoltage()
{
  return analogReadMilliVolts(BATT_ADC_PIN) / 1000.0f * 2.0f;
}

uint8_t WatchFeatures::Battery::GetPercentage()
{
  float voltage = GetVoltage();

  float level = (GetVoltage() - 3.6f) / 0.6f;
  if (level < 0.0f) {
    level = 0.0f;
  } else if (level > 1.0f) {
    level = 1.0f;
  }

  level = 0.5f - sin(asin(1.0f - 2.0f * level) / 3.0f);

  return std::round(level * 100.0f);
}
